
"""
out_ex20170108_model_PC.py

Machine-generated model code

[Generated by:]
    TRE_DEM_MON = 0.0                                                     # [DEM_MON] Demand for Money
          TRE_F = TRE_LAG_F +TRE_T -TRE_DEM_GOOD -TRE_INTDEP +CB_INTDEP   # [F] Financial assets
     TRE_INTDEP = DEP_LAG_r *TRE_LAG_SUP_DEP                              # [INTDEP] Interest paid on Deposit
      TRE_LAG_F = TRE_F (k -1 )                                           # [LAG_F] Previous periods financial assets.
TRE_LAG_SUP_DEP = TRE_SUP_DEP (k -1 )                                     # [LAG_SUP_DEP] Lagged Supply of Deposit
   TRE_PRIM_BAL = TRE_T -TRE_DEM_GOOD                                     # [PRIM_BAL] Government Primary Fiscal Balance
    TRE_SUP_DEP = DEP_DEM_DEP                                             # [SUP_DEP] Supply of Deposit
          TRE_T = TF_T                                                    # [T] Tax revenue received.
     CB_DEM_DEP = CB_F +CB_SUP_MON                                        # [DEM_DEP] Demand for deposits
           CB_F = CB_LAG_F +CB_INTDEP -CB_INTDEP                          # [F] Financial assets
      CB_INTDEP = DEP_LAG_r *CB_LAG_DEM_DEP                               # [INTDEP] Interest received on Deposit
 CB_LAG_DEM_DEP = CB_DEM_DEP (k -1 )                                      # [LAG_DEM_DEP] Lagged demand for Deposit
       CB_LAG_F = CB_F (k -1 )                                            # [LAG_F] Previous periods financial assets.
     CB_SUP_MON = MON_DEM_MON                                             # [SUP_MON] Supply of Money
    HH_AfterTax = HH_PreTax -HH_T                                         # [AfterTax] Aftertax income
    HH_AlphaFin = 0.4000                                                  # [AlphaFin] Parameter for consumption out of financial assets
 HH_AlphaIncome = 0.6000                                                  # [AlphaIncome] Parameter for consumption out of income
     HH_DEM_DEP = 0.5 *HH_F                                               # [DEM_DEP] Demand for deposits
    HH_DEM_GOOD = HH_AlphaIncome *HH_AfterTax +HH_AlphaFin *HH_LAG_F      # [DEM_GOOD] Expenditure on goods consumption
     HH_DEM_MON = 0.5 *HH_F                                               # [DEM_MON] Demand for Money
           HH_F = HH_LAG_F -HH_T +HH_SUP_LAB -HH_DEM_GOOD +HH_INTDEP      # [F] Financial assets
      HH_INTDEP = DEP_LAG_r *HH_LAG_DEM_DEP                               # [INTDEP] Interest received on Deposit
 HH_LAG_DEM_DEP = HH_DEM_DEP (k -1 )                                      # [LAG_DEM_DEP] Lagged demand for Deposit
       HH_LAG_F = HH_F (k -1 )                                            # [LAG_F] Previous periods financial assets.
      HH_PreTax = HH_SUP_LAB                                              # [PreTax] Pretax income
     HH_SUP_LAB = BUS_DEM_LAB                                             # [SUP_LAB] Supply of Labour
           HH_T = TF_TaxRate *HH_PreTax                                   # [T] Taxes paid.
    BUS_DEM_LAB = GOOD_SUP_GOOD                                           # [DEM_LAB] Demand for labour
    BUS_DEM_MON = BUS_F                                                   # [DEM_MON] Demand for Money
          BUS_F = BUS_LAG_F -BUS_DEM_LAB +BUS_SUP_GOOD                    # [F] Financial assets
      BUS_LAG_F = BUS_F (k -1 )                                           # [LAG_F] Previous periods financial assets.
   BUS_SUP_GOOD = TRE_DEM_GOOD +HH_DEM_GOOD                               # [SUP_GOOD] Supply of goods
           TF_T = TF_TaxRate *HH_PreTax                                   # [T] Taxes Paid
     TF_TaxRate = 0.2000                                                  # [TaxRate] Tax rate
    LAB_DEM_LAB = BUS_DEM_LAB                                             # [DEM_LAB] Demand for Market LAB
    LAB_SUP_LAB = LAB_DEM_LAB                                             # [SUP_LAB] Supply for Market LAB
  GOOD_DEM_GOOD = TRE_DEM_GOOD +HH_DEM_GOOD                               # [DEM_GOOD] Demand for Market GOOD
  GOOD_SUP_GOOD = GOOD_DEM_GOOD                                           # [SUP_GOOD] Supply for Market GOOD
    MON_DEM_MON = TRE_DEM_MON +HH_DEM_MON +BUS_DEM_MON                    # [DEM_MON] Total demand for Money
    MON_SUP_MON = CB_SUP_MON                                              # [SUP_MON] Supply of Money
    DEP_DEM_DEP = CB_DEM_DEP +HH_DEM_DEP                                  # [DEM_DEP] Total demand for Deposit
      DEP_LAG_r = DEP_r (k -1 )                                           # [LAG_r] Lagged Interest rate
    DEP_SUP_DEP = TRE_SUP_DEP                                             # [SUP_DEP] Supply of Deposit
        HH_F(0) = 80.0                                                    # Initial Condition

# Exogenous Variables

   TRE_DEM_GOOD =  [20. ,]*105                                            # [DEM_GOOD] Government Consumption of Goods
          DEP_r =  [0.0 ,]*5 +[0.04 ]*100                                 # [r] Interest rate

MaxTime = 100
Err_Tolerance=0.001
"""

from pprint import pprint
# Bring in all the math functions by default.
from math import *

from sfc_models.base_solver import BaseSolver


class SFCModel(BaseSolver):
    """
    Model

    Implements the following system of equations.

    Endogenous variables and parameters
    ===================================
    TRE_DEM_MON = 0.0,
    TRE_F = TRE_LAG_F+TF_T-TRE_DEM_GOOD-TRE_INTDEP+CB_INTDEP,
    TRE_INTDEP = DEP_LAG_r*TRE_LAG_SUP_DEP,
    CB_DEM_DEP = CB_F+MON_DEM_MON,
    CB_F = CB_LAG_F+CB_INTDEP-CB_INTDEP,
    CB_INTDEP = DEP_LAG_r*CB_LAG_DEM_DEP,
    HH_AfterTax = GOOD_DEM_GOOD-HH_T,
    HH_AlphaFin = 0.4000,
    HH_AlphaIncome = 0.6000,
    HH_DEM_DEP = 0.5*HH_F,
    HH_DEM_GOOD = HH_AlphaIncome*HH_AfterTax+HH_AlphaFin*HH_LAG_F,
    HH_DEM_MON = 0.5*HH_F,
    HH_F = HH_LAG_F-HH_T+GOOD_DEM_GOOD-HH_DEM_GOOD+HH_INTDEP,
    HH_INTDEP = DEP_LAG_r*HH_LAG_DEM_DEP,
    HH_T = TF_TaxRate*GOOD_DEM_GOOD,
    BUS_F = BUS_LAG_F-GOOD_DEM_GOOD+BUS_SUP_GOOD,
    BUS_SUP_GOOD = TRE_DEM_GOOD+HH_DEM_GOOD,
    TF_T = TF_TaxRate*GOOD_DEM_GOOD,
    TF_TaxRate = 0.2000,
    GOOD_DEM_GOOD = TRE_DEM_GOOD+HH_DEM_GOOD,
    MON_DEM_MON = TRE_DEM_MON+HH_DEM_MON+BUS_F,
    DEP_DEM_DEP = CB_DEM_DEP+HH_DEM_DEP,
    t = t_minus_1+1.0,
    TRE_PRIM_BAL = TF_T-TRE_DEM_GOOD,
    TRE_SUP_DEP = DEP_DEM_DEP,
    TRE_T = TF_T,
    CB_SUP_MON = MON_DEM_MON,
    HH_PreTax = GOOD_DEM_GOOD,
    HH_SUP_LAB = GOOD_DEM_GOOD,
    BUS_DEM_MON = BUS_F,
    LAB_DEM_LAB = GOOD_DEM_GOOD,
    LAB_SUP_LAB = BUS_DEM_LAB,
    GOOD_SUP_GOOD = GOOD_DEM_GOOD,
    MON_SUP_MON = MON_DEM_MON,
    DEP_SUP_DEP = DEP_DEM_DEP,
    BUS_DEM_LAB = GOOD_DEM_GOOD.
    Where lagged variables are:
    TRE_LAG_F(t) = TRE_F(k-1),
    TRE_LAG_SUP_DEP(t) = TRE_SUP_DEP(k-1),
    CB_LAG_DEM_DEP(t) = CB_DEM_DEP(k-1),
    CB_LAG_F(t) = CB_F(k-1),
    HH_LAG_DEM_DEP(t) = HH_DEM_DEP(k-1),
    HH_LAG_F(t) = HH_F(k-1),
    BUS_LAG_F(t) = BUS_F(k-1),
    DEP_LAG_r(t) = DEP_r(k-1),
    t_minus_1(t) = t(k-1).
    
    Initial Conditions:
    HH_F(0) = 80.0.
    
    Exogenous Variables
    ===================
    TRE_DEM_GOOD,
    DEP_r.

    """
    def __init__(self):
        BaseSolver.__init__(self, ['TRE_DEM_MON', 'TRE_F', 'TRE_INTDEP', 'CB_DEM_DEP', 'CB_F', 'CB_INTDEP', 'HH_AfterTax', 'HH_AlphaFin', 'HH_AlphaIncome', 'HH_DEM_DEP', 'HH_DEM_GOOD', 'HH_DEM_MON', 'HH_F', 'HH_INTDEP', 'HH_T', 'BUS_F', 'BUS_SUP_GOOD', 'TF_T', 'TF_TaxRate', 'GOOD_DEM_GOOD', 'MON_DEM_MON', 'DEP_DEM_DEP', 't', 'TRE_PRIM_BAL', 'TRE_SUP_DEP', 'TRE_T', 'CB_SUP_MON', 'HH_PreTax', 'HH_SUP_LAB', 'BUS_DEM_MON', 'LAB_DEM_LAB', 'LAB_SUP_LAB', 'GOOD_SUP_GOOD', 'MON_SUP_MON', 'DEP_SUP_DEP', 'BUS_DEM_LAB', 'TRE_DEM_GOOD', 'DEP_r'])
        self.MaxIterations = 400
        self.MaxTime = 100
        # Current time step. Call this "STEP" and not time so that users
        # can create a custom time axis variable.
        self.STEP = 0
        self.PrintIterations = False
        self.Err_Tolerance = 0.001
        self.TRE_DEM_MON = [0.0, ]
        self.TRE_F = [0., ]
        self.TRE_INTDEP = [0., ]
        self.CB_DEM_DEP = [0., ]
        self.CB_F = [0., ]
        self.CB_INTDEP = [0., ]
        self.HH_AfterTax = [0., ]
        self.HH_AlphaFin = [0.4000, ]
        self.HH_AlphaIncome = [0.6000, ]
        self.HH_DEM_DEP = [0., ]
        self.HH_DEM_GOOD = [0., ]
        self.HH_DEM_MON = [0., ]
        self.HH_F = [80.0, ]
        self.HH_INTDEP = [0., ]
        self.HH_T = [0., ]
        self.BUS_F = [0., ]
        self.BUS_SUP_GOOD = [0., ]
        self.TF_T = [0., ]
        self.TF_TaxRate = [0.2000, ]
        self.GOOD_DEM_GOOD = [0., ]
        self.MON_DEM_MON = [0., ]
        self.DEP_DEM_DEP = [0., ]
        self.t = [0., ]
        self.TRE_PRIM_BAL = [0., ]
        self.TRE_SUP_DEP = [0., ]
        self.TRE_T = [0., ]
        self.CB_SUP_MON = [0., ]
        self.HH_PreTax = [0., ]
        self.HH_SUP_LAB = [0., ]
        self.BUS_DEM_MON = [0., ]
        self.LAB_DEM_LAB = [0., ]
        self.LAB_SUP_LAB = [0., ]
        self.GOOD_SUP_GOOD = [0., ]
        self.MON_SUP_MON = [0., ]
        self.DEP_SUP_DEP = [0., ]
        self.BUS_DEM_LAB = [0., ]
        self.TRE_DEM_GOOD = [20. ,]*105
        self.DEP_r = [0.0 ,]*5 +[0.04 ]*100
        #  Make sure exogenous variables are not longer than time frame
        self.TRE_DEM_GOOD = self.TRE_DEM_GOOD[0:101]
        self.DEP_r = self.DEP_r[0:101]


    @staticmethod
    def Iterator(in_vec):
        TRE_DEM_MON, TRE_F, TRE_INTDEP, CB_DEM_DEP, CB_F, CB_INTDEP, HH_AfterTax, HH_AlphaFin, HH_AlphaIncome, HH_DEM_DEP, HH_DEM_GOOD, HH_DEM_MON, HH_F, HH_INTDEP, HH_T, BUS_F, BUS_SUP_GOOD, TF_T, TF_TaxRate, GOOD_DEM_GOOD, MON_DEM_MON, DEP_DEM_DEP, t, TRE_PRIM_BAL, TRE_SUP_DEP, TRE_T, CB_SUP_MON, HH_PreTax, HH_SUP_LAB, BUS_DEM_MON, LAB_DEM_LAB, LAB_SUP_LAB, GOOD_SUP_GOOD, MON_SUP_MON, DEP_SUP_DEP, BUS_DEM_LAB, TRE_LAG_F, TRE_LAG_SUP_DEP, CB_LAG_DEM_DEP, CB_LAG_F, HH_LAG_DEM_DEP, HH_LAG_F, BUS_LAG_F, DEP_LAG_r, t_minus_1, TRE_DEM_GOOD, DEP_r = in_vec 
        NEW_TRE_DEM_MON = 0.0
        NEW_TRE_F = TRE_LAG_F+TF_T-TRE_DEM_GOOD-TRE_INTDEP+CB_INTDEP
        NEW_TRE_INTDEP = DEP_LAG_r*TRE_LAG_SUP_DEP
        NEW_CB_DEM_DEP = CB_F+MON_DEM_MON
        NEW_CB_F = CB_LAG_F+CB_INTDEP-CB_INTDEP
        NEW_CB_INTDEP = DEP_LAG_r*CB_LAG_DEM_DEP
        NEW_HH_AfterTax = GOOD_DEM_GOOD-HH_T
        NEW_HH_AlphaFin = 0.4000
        NEW_HH_AlphaIncome = 0.6000
        NEW_HH_DEM_DEP = 0.5*HH_F
        NEW_HH_DEM_GOOD = HH_AlphaIncome*HH_AfterTax+HH_AlphaFin*HH_LAG_F
        NEW_HH_DEM_MON = 0.5*HH_F
        NEW_HH_F = HH_LAG_F-HH_T+GOOD_DEM_GOOD-HH_DEM_GOOD+HH_INTDEP
        NEW_HH_INTDEP = DEP_LAG_r*HH_LAG_DEM_DEP
        NEW_HH_T = TF_TaxRate*GOOD_DEM_GOOD
        NEW_BUS_F = BUS_LAG_F-GOOD_DEM_GOOD+BUS_SUP_GOOD
        NEW_BUS_SUP_GOOD = TRE_DEM_GOOD+HH_DEM_GOOD
        NEW_TF_T = TF_TaxRate*GOOD_DEM_GOOD
        NEW_TF_TaxRate = 0.2000
        NEW_GOOD_DEM_GOOD = TRE_DEM_GOOD+HH_DEM_GOOD
        NEW_MON_DEM_MON = TRE_DEM_MON+HH_DEM_MON+BUS_F
        NEW_DEP_DEM_DEP = CB_DEM_DEP+HH_DEM_DEP
        NEW_t = t_minus_1+1.0
        NEW_TRE_PRIM_BAL = TF_T-TRE_DEM_GOOD
        NEW_TRE_SUP_DEP = DEP_DEM_DEP
        NEW_TRE_T = TF_T
        NEW_CB_SUP_MON = MON_DEM_MON
        NEW_HH_PreTax = GOOD_DEM_GOOD
        NEW_HH_SUP_LAB = GOOD_DEM_GOOD
        NEW_BUS_DEM_MON = BUS_F
        NEW_LAB_DEM_LAB = GOOD_DEM_GOOD
        NEW_LAB_SUP_LAB = BUS_DEM_LAB
        NEW_GOOD_SUP_GOOD = GOOD_DEM_GOOD
        NEW_MON_SUP_MON = MON_DEM_MON
        NEW_DEP_SUP_DEP = DEP_DEM_DEP
        NEW_BUS_DEM_LAB = GOOD_DEM_GOOD
        NEW_TRE_LAG_F = TRE_LAG_F
        NEW_TRE_LAG_SUP_DEP = TRE_LAG_SUP_DEP
        NEW_CB_LAG_DEM_DEP = CB_LAG_DEM_DEP
        NEW_CB_LAG_F = CB_LAG_F
        NEW_HH_LAG_DEM_DEP = HH_LAG_DEM_DEP
        NEW_HH_LAG_F = HH_LAG_F
        NEW_BUS_LAG_F = BUS_LAG_F
        NEW_DEP_LAG_r = DEP_LAG_r
        NEW_t_minus_1 = t_minus_1
        NEW_TRE_DEM_GOOD = TRE_DEM_GOOD
        NEW_DEP_r = DEP_r
        return NEW_TRE_DEM_MON, NEW_TRE_F, NEW_TRE_INTDEP, NEW_CB_DEM_DEP, NEW_CB_F, NEW_CB_INTDEP, NEW_HH_AfterTax, NEW_HH_AlphaFin, NEW_HH_AlphaIncome, NEW_HH_DEM_DEP, NEW_HH_DEM_GOOD, NEW_HH_DEM_MON, NEW_HH_F, NEW_HH_INTDEP, NEW_HH_T, NEW_BUS_F, NEW_BUS_SUP_GOOD, NEW_TF_T, NEW_TF_TaxRate, NEW_GOOD_DEM_GOOD, NEW_MON_DEM_MON, NEW_DEP_DEM_DEP, NEW_t, NEW_TRE_PRIM_BAL, NEW_TRE_SUP_DEP, NEW_TRE_T, NEW_CB_SUP_MON, NEW_HH_PreTax, NEW_HH_SUP_LAB, NEW_BUS_DEM_MON, NEW_LAB_DEM_LAB, NEW_LAB_SUP_LAB, NEW_GOOD_SUP_GOOD, NEW_MON_SUP_MON, NEW_DEP_SUP_DEP, NEW_BUS_DEM_LAB, NEW_TRE_LAG_F, NEW_TRE_LAG_SUP_DEP, NEW_CB_LAG_DEM_DEP, NEW_CB_LAG_F, NEW_HH_LAG_DEM_DEP, NEW_HH_LAG_F, NEW_BUS_LAG_F, NEW_DEP_LAG_r, NEW_t_minus_1, NEW_TRE_DEM_GOOD, NEW_DEP_r


    def main(self):
        while self.STEP < self.MaxTime:
            self.RunOneStep()

    def RunOneStep(self):
        self.STEP += 1
        TRE_DEM_MON = self.TRE_DEM_MON[-1]
        TRE_F = self.TRE_F[-1]
        TRE_INTDEP = self.TRE_INTDEP[-1]
        CB_DEM_DEP = self.CB_DEM_DEP[-1]
        CB_F = self.CB_F[-1]
        CB_INTDEP = self.CB_INTDEP[-1]
        HH_AfterTax = self.HH_AfterTax[-1]
        HH_AlphaFin = self.HH_AlphaFin[-1]
        HH_AlphaIncome = self.HH_AlphaIncome[-1]
        HH_DEM_DEP = self.HH_DEM_DEP[-1]
        HH_DEM_GOOD = self.HH_DEM_GOOD[-1]
        HH_DEM_MON = self.HH_DEM_MON[-1]
        HH_F = self.HH_F[-1]
        HH_INTDEP = self.HH_INTDEP[-1]
        HH_T = self.HH_T[-1]
        BUS_F = self.BUS_F[-1]
        BUS_SUP_GOOD = self.BUS_SUP_GOOD[-1]
        TF_T = self.TF_T[-1]
        TF_TaxRate = self.TF_TaxRate[-1]
        GOOD_DEM_GOOD = self.GOOD_DEM_GOOD[-1]
        MON_DEM_MON = self.MON_DEM_MON[-1]
        DEP_DEM_DEP = self.DEP_DEM_DEP[-1]
        t = self.t[-1]
        TRE_PRIM_BAL = self.TRE_PRIM_BAL[-1]
        TRE_SUP_DEP = self.TRE_SUP_DEP[-1]
        TRE_T = self.TRE_T[-1]
        CB_SUP_MON = self.CB_SUP_MON[-1]
        HH_PreTax = self.HH_PreTax[-1]
        HH_SUP_LAB = self.HH_SUP_LAB[-1]
        BUS_DEM_MON = self.BUS_DEM_MON[-1]
        LAB_DEM_LAB = self.LAB_DEM_LAB[-1]
        LAB_SUP_LAB = self.LAB_SUP_LAB[-1]
        GOOD_SUP_GOOD = self.GOOD_SUP_GOOD[-1]
        MON_SUP_MON = self.MON_SUP_MON[-1]
        DEP_SUP_DEP = self.DEP_SUP_DEP[-1]
        BUS_DEM_LAB = self.BUS_DEM_LAB[-1]
        TRE_LAG_F = self.TRE_F[self.STEP -1]
        TRE_LAG_SUP_DEP = self.TRE_SUP_DEP[self.STEP -1]
        CB_LAG_DEM_DEP = self.CB_DEM_DEP[self.STEP -1]
        CB_LAG_F = self.CB_F[self.STEP -1]
        HH_LAG_DEM_DEP = self.HH_DEM_DEP[self.STEP -1]
        HH_LAG_F = self.HH_F[self.STEP -1]
        BUS_LAG_F = self.BUS_F[self.STEP -1]
        DEP_LAG_r = self.DEP_r[self.STEP -1]
        t_minus_1 = self.t[self.STEP -1]
        TRE_DEM_GOOD = self.TRE_DEM_GOOD[self.STEP]
        DEP_r = self.DEP_r[self.STEP]

        orig_vector = (TRE_DEM_MON, TRE_F, TRE_INTDEP, CB_DEM_DEP, CB_F, CB_INTDEP, HH_AfterTax, HH_AlphaFin, HH_AlphaIncome, HH_DEM_DEP, HH_DEM_GOOD, HH_DEM_MON, HH_F, HH_INTDEP, HH_T, BUS_F, BUS_SUP_GOOD, TF_T, TF_TaxRate, GOOD_DEM_GOOD, MON_DEM_MON, DEP_DEM_DEP, t, TRE_PRIM_BAL, TRE_SUP_DEP, TRE_T, CB_SUP_MON, HH_PreTax, HH_SUP_LAB, BUS_DEM_MON, LAB_DEM_LAB, LAB_SUP_LAB, GOOD_SUP_GOOD, MON_SUP_MON, DEP_SUP_DEP, BUS_DEM_LAB, TRE_LAG_F, TRE_LAG_SUP_DEP, CB_LAG_DEM_DEP, CB_LAG_F, HH_LAG_DEM_DEP, HH_LAG_F, BUS_LAG_F, DEP_LAG_r, t_minus_1, TRE_DEM_GOOD, DEP_r)
        err = 1.
        cnt = 0
        while err > self.Err_Tolerance:
            new_vector = self.Iterator(orig_vector)
            err = self.CalcError(orig_vector, new_vector)
            orig_vector = new_vector
            cnt += 1
            if cnt > self.MaxIterations:
                raise ValueError('No Convergence!')
        if self.PrintIterations:
            pprint(cnt)
        TRE_DEM_MON = orig_vector[0]
        self.TRE_DEM_MON.append(TRE_DEM_MON)
        TRE_F = orig_vector[1]
        self.TRE_F.append(TRE_F)
        TRE_INTDEP = orig_vector[2]
        self.TRE_INTDEP.append(TRE_INTDEP)
        CB_DEM_DEP = orig_vector[3]
        self.CB_DEM_DEP.append(CB_DEM_DEP)
        CB_F = orig_vector[4]
        self.CB_F.append(CB_F)
        CB_INTDEP = orig_vector[5]
        self.CB_INTDEP.append(CB_INTDEP)
        HH_AfterTax = orig_vector[6]
        self.HH_AfterTax.append(HH_AfterTax)
        HH_AlphaFin = orig_vector[7]
        self.HH_AlphaFin.append(HH_AlphaFin)
        HH_AlphaIncome = orig_vector[8]
        self.HH_AlphaIncome.append(HH_AlphaIncome)
        HH_DEM_DEP = orig_vector[9]
        self.HH_DEM_DEP.append(HH_DEM_DEP)
        HH_DEM_GOOD = orig_vector[10]
        self.HH_DEM_GOOD.append(HH_DEM_GOOD)
        HH_DEM_MON = orig_vector[11]
        self.HH_DEM_MON.append(HH_DEM_MON)
        HH_F = orig_vector[12]
        self.HH_F.append(HH_F)
        HH_INTDEP = orig_vector[13]
        self.HH_INTDEP.append(HH_INTDEP)
        HH_T = orig_vector[14]
        self.HH_T.append(HH_T)
        BUS_F = orig_vector[15]
        self.BUS_F.append(BUS_F)
        BUS_SUP_GOOD = orig_vector[16]
        self.BUS_SUP_GOOD.append(BUS_SUP_GOOD)
        TF_T = orig_vector[17]
        self.TF_T.append(TF_T)
        TF_TaxRate = orig_vector[18]
        self.TF_TaxRate.append(TF_TaxRate)
        GOOD_DEM_GOOD = orig_vector[19]
        self.GOOD_DEM_GOOD.append(GOOD_DEM_GOOD)
        MON_DEM_MON = orig_vector[20]
        self.MON_DEM_MON.append(MON_DEM_MON)
        DEP_DEM_DEP = orig_vector[21]
        self.DEP_DEM_DEP.append(DEP_DEM_DEP)
        t = orig_vector[22]
        self.t.append(t)
        TRE_PRIM_BAL = orig_vector[23]
        self.TRE_PRIM_BAL.append(TRE_PRIM_BAL)
        TRE_SUP_DEP = orig_vector[24]
        self.TRE_SUP_DEP.append(TRE_SUP_DEP)
        TRE_T = orig_vector[25]
        self.TRE_T.append(TRE_T)
        CB_SUP_MON = orig_vector[26]
        self.CB_SUP_MON.append(CB_SUP_MON)
        HH_PreTax = orig_vector[27]
        self.HH_PreTax.append(HH_PreTax)
        HH_SUP_LAB = orig_vector[28]
        self.HH_SUP_LAB.append(HH_SUP_LAB)
        BUS_DEM_MON = orig_vector[29]
        self.BUS_DEM_MON.append(BUS_DEM_MON)
        LAB_DEM_LAB = orig_vector[30]
        self.LAB_DEM_LAB.append(LAB_DEM_LAB)
        LAB_SUP_LAB = orig_vector[31]
        self.LAB_SUP_LAB.append(LAB_SUP_LAB)
        GOOD_SUP_GOOD = orig_vector[32]
        self.GOOD_SUP_GOOD.append(GOOD_SUP_GOOD)
        MON_SUP_MON = orig_vector[33]
        self.MON_SUP_MON.append(MON_SUP_MON)
        DEP_SUP_DEP = orig_vector[34]
        self.DEP_SUP_DEP.append(DEP_SUP_DEP)
        BUS_DEM_LAB = orig_vector[35]
        self.BUS_DEM_LAB.append(BUS_DEM_LAB)


    @staticmethod
    def CalcError(vec1, vec2):
        err = 0.
        for val1, val2 in zip(vec1, vec2):
            err += abs(val1 - val2)
        return err

if __name__ == '__main__':
    obj = SFCModel()
    obj.main()
